// BonCasServerDlg.cpp : t@C
//

#include "stdafx.h"
#include "BonCasServer.h"
#include "BonCasServerDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif


// AvP[Ṽo[WɎg CAboutDlg _CAO

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// _CAO f[^
	enum { IDD = IDD_ABOUTBOX };

	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV T|[g

// 
protected:
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
END_MESSAGE_MAP()


// CBonCasServerDlg _CAO




CBonCasServerDlg::CBonCasServerDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CBonCasServerDlg::IDD, pParent)
	, m_CasServer(this)
	, m_NotifyIcon(this)
	, m_dwServerPort(CONFSECT_GENERAL, TEXT("ServerPort"), 6900UL, 65535UL)
{
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CBonCasServerDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	DDX_Text(pDX, IDC_SERVERPORT, m_dwServerPort);
	DDV_MinMaxUInt(pDX, m_dwServerPort, 0, 65535);
}

BEGIN_MESSAGE_MAP(CBonCasServerDlg, CDialog)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	//}}AFX_MSG_MAP
	ON_WM_DESTROY()
	ON_COMMAND(ID_MENU_SETUP, &CBonCasServerDlg::OnMenuSetup)
	ON_COMMAND(ID_MENU_ABOUT, &CBonCasServerDlg::OnMenuAbout)
	ON_COMMAND(ID_MENU_EXIT, &CBonCasServerDlg::OnMenuExit)
END_MESSAGE_MAP()


// CBonCasServerDlg bZ[W nh

BOOL CBonCasServerDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// "o[W..." j[VXe j[ɒǉ܂B

	// IDM_ABOUTBOX ́AVXe R}h͈͓̔ɂȂ΂Ȃ܂B
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// ̃_CAÕACRݒ肵܂BAvP[ṼC EBhE_CAOłȂꍇA
	//  Framework ́A̐ݒIɍs܂B
	SetIcon(m_hIcon, TRUE);			// 傫ACR̐ݒ
	SetIcon(m_hIcon, FALSE);		// ACR̐ݒ

	// TODO: ɒǉ܂B

	// T[oI[v
	if(!m_CasServer.OpenServer((WORD)m_dwServerPort)){
		::AfxMessageBox(TEXT("T[őNɎs܂B\r\nTCP|[g܂̓J[h[_I[vł܂B"));
		return TRUE;
		}

	// ^XNgCɃACRǉ
	m_NotifyIcon.AddIcon(GetSafeHwnd(), ::AfxGetApp()->LoadIcon(IDI_BLUECARD), APP_TITLE TEXT("\r\nڑ̃NCAgF 0"));

	return TRUE;  // tH[JXRg[ɐݒ肵ꍇATRUE Ԃ܂B
}

void CBonCasServerDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// _CAOɍŏ{^ǉꍇAACR`悷邽߂
//  ̃R[hKvłBhLg/r[ fg MFC AvP[V̏ꍇA
//  ́AFramework ɂĎIɐݒ肳܂B

void CBonCasServerDlg::OnPaint()
{
	if (IsIconic())
	{
		CPaintDC dc(this); // `̃foCX ReLXg

		SendMessage(WM_ICONERASEBKGND, reinterpret_cast<WPARAM>(dc.GetSafeHdc()), 0);

		// NCAg̎lp`̈̒
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// ACR̕`
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// [U[ŏEBhEhbOĂƂɕ\J[\擾邽߂ɁA
//  VXe̊֐Ăяo܂B
HCURSOR CBonCasServerDlg::OnQueryDragIcon()
{
	return static_cast<HCURSOR>(m_hIcon);
}


void CBonCasServerDlg::OnDestroy()
{
	CDialog::OnDestroy();

	// TODO: ɃbZ[W nh R[hǉ܂B
	m_CasServer.CloseServer();

	// ^XNgC̃ACR폜
	m_NotifyIcon.RemoveIcon();
}

void CBonCasServerDlg::OnOK(void)
{
	const DWORD dwPrevPort = m_dwServerPort;

	if(!UpdateData(TRUE))return;

	if((m_dwServerPort != dwPrevPort) && m_CasServer.GetClientNum()){
		if(::AfxMessageBox(TEXT("ڑ̃NCAg݂܂BؒfĐݒ𔽉f܂H\r\n\r\nuvIꍇ͎Nɔf܂B"), MB_YESNO) == IDYES){
			
			// T[oċN
			m_CasServer.CloseServer();
			if(!m_CasServer.OpenServer((WORD)m_dwServerPort)){
				::AfxMessageBox(TEXT("T[őNɎs܂B\r\nTCP|[g܂̓J[h[_I[vł܂B"));
				return;
				}
	
			}		
		}

	ShowWindow(SW_HIDE);
}

void CBonCasServerDlg::OnCancel(void)
{
	UpdateData(FALSE);
	ShowWindow(SW_HIDE);
}

void CBonCasServerDlg::UpdateToolTip(void)
{
	CString csText;
	csText.Format(TEXT("%s\r\nڑ̃NCAgF %ld"), APP_TITLE, m_CasServer.GetClientNum());

	m_NotifyIcon.SetTip(csText);
}

void CBonCasServerDlg::ShowContextMenu(void)
{
	// |bvAbvj[\
	CPoint ptPos;
	::GetCursorPos(&ptPos);

	CMenu BaseMenu;
	BaseMenu.LoadMenu(IDR_MENU);
	CMenu *pPopupMenu = BaseMenu.GetSubMenu(0);
	
	SetForegroundWindow();
	pPopupMenu->TrackPopupMenu(TPM_LEFTALIGN | TPM_BOTTOMALIGN | TPM_LEFTBUTTON | TPM_RIGHTBUTTON, ptPos.x, ptPos.y, this);
	BaseMenu.DestroyMenu();
	PostMessage(WM_USER);
}

void CBonCasServerDlg::OnCasServerEvent(CCasServer *pCasServer, const WORD wEventID)
{
	switch(wEventID){
		case CCasServer::CSEI_CONNECTED :
		case CCasServer::CSEI_DISCONNECTED :
			m_NotifyIcon.SetIcon(::AfxGetApp()->LoadIcon((pCasServer->GetClientNum())? IDI_REDCARD : IDI_BLUECARD));
			UpdateToolTip();
			break;
		}
}

void CBonCasServerDlg::OnNotifyIconEvent(CNotifyIcon *pNotifyIcon, const WORD wEventID)
{
	// ^XNgCACRCxg
	switch(wEventID){
		case WM_LBUTTONUP :
			// NbN
			ShowContextMenu();
			break;
		
		case WM_RBUTTONUP :
			// ENbN
			ShowContextMenu();
			break;
		}
}

void CBonCasServerDlg::OnMenuSetup()
{
	// TODO: ɃR}h nh R[hǉ܂B
	ShowWindow(SW_SHOW);
	SetForegroundWindow();
}

void CBonCasServerDlg::OnMenuAbout()
{
	// TODO: ɃR}h nh R[hǉ܂B
	CAboutDlg AboutDlg;
	AboutDlg.DoModal();
}

void CBonCasServerDlg::OnMenuExit()
{
	// TODO: ɃR}h nh R[hǉ܂B
	if(m_CasServer.GetClientNum()){
		if(::AfxMessageBox(TEXT("ڑ̃NCAg݂܂B\r\nI܂H"), MB_YESNO | MB_ICONEXCLAMATION) != IDYES)return;
		}

	DestroyWindow();
}
